//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#define MAXCHANNELNAMELEN 50
#define MAXTOPICLEN 300
struct weircd_channel {
	unsigned char name[MAXCHANNELNAMELEN + 1];
	unsigned char topic[MAXTOPICLEN + 1];
	bool mode_moderated;
	bool mode_topiclock;
	bool mode_registered;
};
struct weircd_channel* chans[COMPILEOPTION_MAXCHANS];
void weircdChannelsInit() {
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		chans[r] = NULL;
		r += 1;
	}
}
int getChanID(const unsigned char* channame) {
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] != NULL) {
			if (strcasecmp(chans[r]->name,channame) == 0) {
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
int addChan(const unsigned char* channame) {
	int r = getChanID(channame);
	if (r >= 0) {return r;}
	r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] == NULL) {
			chans[r] = malloc(sizeof(struct weircd_channel));
			if (chans[r] != NULL) {
				memset(chans[r],0,sizeof(struct weircd_channel));
				strcpy(chans[r]->name,channame);
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
bool isOppedOnJoin(const unsigned char* channame) {
	int r = getChanID(channame);
	if (r >= 0) {return false;}
	return true;
}
unsigned char* cn(const unsigned char* vcn) {
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] != NULL) {
			if (strcasecmp(chans[r]->name,vcn) == 0) {
				return chans[r]->name;
			}
		}
		r += 1;
	}
	return NULL;
}
