//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

bool isfakeservicesuser(const unsigned char* usr) {
	if (cuo.services_activated == 1) {
		if (strcasecmp(usr,"chanserv") == 0) {return true;}
		if (strcasecmp(usr,"nickserv") == 0) {return true;}
		if (strcasecmp(usr,"global") == 0) {return true;}
		if (strcasecmp(usr,"operserv") == 0) {return true;}
	}
	return false;
}
void writeservicesnick(unsigned char* usr) {
	if (strcasecmp(usr,"chanserv") == 0) {strcpy(usr,"ChanServ");}
	if (strcasecmp(usr,"nickserv") == 0) {strcpy(usr,"NickServ");}
	if (strcasecmp(usr,"global") == 0) {strcpy(usr,"Global");}
	if (strcasecmp(usr,"operserv") == 0) {strcpy(usr,"OperServ");}
}
sqlite3 *nickdb;
bool services_db_init() {
	char *zErrMsg = 0;
	int dbp;
	printf("%s    > Opening the nick database...\n",startupprefixsub);
	dbp = sqlite3_open("/etc/weircd/nick.db", &nickdb);
	if (dbp) {
		printf("%s          -Failed to open /etc/weircd/nick.db!\n",startupprefixsub);
		sqlite3_close(nickdb);
		return false;
	}
	printf("%s          -Database opened\n",startupprefixsub);
	dbp = sqlite3_exec(nickdb,"CREATE TABLE IF NOT EXISTS usertable ( useraccount_name TEXT, useraccount_password TEXT, useraccount_email TEXT, useraccount_registertime INTEGER, userid INTEGER PRIMARY KEY AUTOINCREMENT )",NULL,0,&zErrMsg);
	if (dbp!=SQLITE_OK) {
		sqlite3_free(zErrMsg);printf("%s          -Failed to insert default table\n",startupprefixsub);
	return false;}
	return true;
}
void services_db_stop() {
	sqlite3_close(nickdb);
}
bool weircdServicesInit() {
	printf("%s Loading IRC services module...\n",startupprefix);
	if (services_db_init() != true) {return false;}
	return true;
}
unsigned char* services_upassword(const unsigned char* nickname) {
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	if (strlen(lclnick) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM usertable WHERE useraccount_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GNick: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {
		printf("GNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"useraccount_password") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
unsigned char* services_getemail(const unsigned char* nickname) {
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	if (strlen(lclnick) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM usertable WHERE useraccount_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GNick: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {
		printf("GNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"useraccount_email") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
bool services_registernick(const unsigned char* nickname, const unsigned char* pw, const unsigned char* mail) {
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	if (strlen(lclnick) <= 0) {return false;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"INSERT INTO usertable VALUES(?,?,?,?,?)",-1,&stmt,0) != SQLITE_OK) {
		printf("RNick: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,1,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {
		printf("RNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,2,pw,strlen(pw),SQLITE_STATIC) != SQLITE_OK) {
		printf("RNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,3,mail,strlen(mail),SQLITE_STATIC) != SQLITE_OK) {
		printf("RNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_int (stmt,4,time(NULL)) != SQLITE_OK) {
		printf("RNick: Could not bind int.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	sqlite3_step(stmt);
	sqlite3_finalize(stmt);
	return true;
}
bool services_userregistered(const unsigned char* nickname) {
	unsigned char* r;
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);
	r = services_upassword(lclnick);
	if (r == NULL) {return true;}//an error occured, block the nickname until prob is solved
	if (strcasecmp(r,"") == 0) {free(r);return false;}else{free(r);return true;}
}
void services_say(const unsigned char* service,const unsigned char* stuff,int uid) {
	unsigned char response[501];
	snprintf(&response[0],499,":%s!services@%s NOTICE %s :%s\n",service,cuo.serviceshost,un(uid),stuff);
	response[499] = 0;vsnd(response,uid);
}
void services_nickserv(int uid,const unsigned char* cmd, unsigned char* params) {
	unsigned char response[501];
	unsigned char willpw[50];
	int r,k;
	if (strcasecmp(cmd,"help") == 0) {
		trimleft(params);
		cutonfirstspace(params);
		if (strcasecmp(params,"") == 0) {
			snprintf(&response[0],499,"%c- NickServ help -%c",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  You can use NickServ to register a nick,",uid);
			services_say("NickServ","   this prevents others from using it and makes",uid);
			services_say("NickServ","   sure that only you can use it and others never",uid);
			services_say("NickServ","   have to bother if it's you or someone else",uid);
			services_say("NickServ","   abusing your nick to pretend to be you.",uid);
			services_say("NickServ"," ",uid);
			snprintf(&response[0],499,"  Type %c/msg NickServ help commands%c to get a list",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   of all available commands.",uid);
			snprintf(&response[0],499,"  Type %c/msg NickServ help register%c to get some",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   information on how to register your nickname",uid);
			services_say("NickServ","   to protect from others.",uid);
			services_say("NickServ","  If this doesn't help you and you still have",uid);
			snprintf(&response[0],499,"   trouble using NickServ, use %c/join %s%c",2,cuo.helpchan,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   to get help.",uid);
			return;
		}
		if (strcasecmp(params,"commands") == 0) {
			snprintf(&response[0],499,"%c- NickServ help - %cRegister%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  Here is a list of all available nickserv commands",uid);
			snprintf(&response[0],499,"   (type %c/msg nickserv help <command>%c to get",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","    more information on one of those commands):",uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","    HELP",uid);
			services_say("NickServ","    REGISTER",uid);
			services_say("NickServ","    UNREGISTER",uid);
			services_say("NickServ","    INFO",uid);
			if (userpointers[uid]->ircop == true) {
				snprintf(&response[0],499,"%cIRCop commands:%c DROP, STATS, SETPASS",2,2);
				response[499] = 0;
				services_say("NickServ",response,uid);
			}
			return;
		}
		if (strcasecmp(params,"register") == 0) {
			snprintf(&response[0],499,"%c- NickServ help - %cRegister%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  You can register your current nickname using",uid);
			snprintf(&response[0],499,"   the command %c/msg nickserv register <password> <e-mail>%c!",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			snprintf(&response[0],499,"   (Please replace %c<password>%c and %c<e-mail>%c with proper",2,2,2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","    values!)",uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  This will protect this nick and only who enter your",uid);
			services_say("NickServ","   secret password as server password on connect will",uid);
			services_say("NickServ","   be able to use your nickname.",uid);
			services_say("NickServ","  If you ever forget your secret password yourself,",uid);
			snprintf(&response[0],499,"   go to %s and ask for a new password being sent to",cuo.helpchan);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   the e-mail address you entered.",uid);
			services_say("NickServ","  Only server admins will be able to see the e-mail",uid);
			services_say("NickServ","   address you entered.",uid);
			return;
		}
		snprintf(&response[0],499,"No help available for %s",params);
		response[499] = 0;
		services_say("NickServ",response,uid);
		return;
	}
	if (strcasecmp(cmd,"info") == 0) {
		trimleft(params);cutonfirstspace(params);
		if (services_userregistered(params) == true) {
			snprintf(&response[0],499,"Username %c%s%c is %cregistered%c.",34,params,34,2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			if (userpointers[uid]->ircop == true) {
				unsigned char* j = NULL;
				j = services_getemail(params);
				if (j != NULL) {
					snprintf(&response[0],499,"The %ce-mail%c address of %c%s%c is %s",2,2,34,params,34,j);
					response[499] = 0;
					services_say("NickServ",response,uid);
					free(j);
				}else{
					snprintf(&response[0],499,"The %ce-mail%c address of %c%s%c is >>null<<",2,2,34,params,34);
					response[499] = 0;
					services_say("NickServ",response,uid);
				}
				return;
			}else{
				userpointers[uid]->floodprotect.floodpoints += 2;
			}
			return;
		}else{
			snprintf(&response[0],499,"Username %c%s%c is %cfree%c.",34,params,34,2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}
	}
	if (strcasecmp(cmd,"register") == 0) {
		if (userpointers[uid]->accountname != NULL) {
			snprintf(&response[0],499,"You are already logged in as %c%s%c.",2,userpointers[uid]->accountname,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}else{
			if (userpointers[uid]->lastnickchange + cuo.nickwaittime > time(NULL)) {
				snprintf(&response[0],499,"Please wait %c%d seconds%c before you attempt to register your nickname (register flood protection)",2,(userpointers[uid]->lastnickchange + cuo.nickwaittime) - time(NULL),2);
				response[499] = 0;
				services_say("NickServ",response,uid);
				return;
			}else{
				if (strcasecmp(userpointers[uid]->nickname,"guest") == 0 || strstw(userpointers[uid]->nickname,"guest") == true) {
					services_say("NickServ","You cannot register this nickname.",uid);
				}else{
					trimleft(params);
					if (strlen(params) <= 2 || charpos(params,32) <= 0) {
						snprintf(&response[0],499,"Register: There are some parameters missing! Use %c%/msg nickserv help register%c to check the correct syntax of this command",2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					strncpy(willpw,params,49);willpw[49] = 0;
					cutonfirstspace(willpw);
					cut(params,charpos(params,32) + 1);
					cutonfirstspace(params);
					if (strlen(params) < 1 || strlen(willpw) < 1) {
						snprintf(&response[0],499,"Register: There are some parameters missing! Use %c%/msg nickserv help register%c to check the correct syntax of this command",2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					if (charpos(params,'@') <= 0) {
						snprintf(&response[0],499,"Register: The second parameter should be a %cvalid%c e-mail address - without a working e-mail address, your %caccount will be lost%c if you ever forget your password.",2,2,2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					if (strlen(willpw) < 8 || strcasecmp(willpw,"password") == 0 || strcasecmp(willpw,"<password>") == 0) {
						snprintf(&response[0],499,"It is important that your password is very random and not too short. In case you can't remember it one day, you can ask for a new password in %s which will be send to your e-mail address, so don't fear to use a complicated password! %cThis password is too weak.%c",cuo.helpchan,2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					if (services_registernick(userpointers[uid]->nickname,willpw,params) == false) {
						snprintf(&response[0],499,"The %cregistration failed%c (Technical problem: database reports error). Please join %s for help.",2,2,cuo.helpchan);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}else{
						userpointers[uid]->accountname = malloc(strlen(userpointers[uid]->nickname) + 1);
						if (userpointers[uid]->accountname == NULL) {
							snprintf(&response[0],499,"The %cregistration failed%c (Technical problem: database reports error). Please join %s for help.",2,2,cuo.helpchan);
							response[499] = 0;
							services_say("NickServ",response,uid);
							return;
						}else{
							strcpy(userpointers[uid]->accountname,userpointers[uid]->nickname);
							strlwr(userpointers[uid]->accountname);
							snprintf(&response[0],499,"Your nickname %c%s%c is now registered.",2,userpointers[uid]->nickname,2);
							response[499] = 0;
							services_say("NickServ",response,uid);
							return;
						}
					}
				}
			}
		}
	}
	snprintf(&response[0],499,"Unknown command. Type %c/NickServ help%c for a command listing.",2,2);
	response[499] = 0;
	services_say("NickServ",response,uid);
}
void services_chanserv(int uid,const unsigned char* cmd, unsigned char* params) {
	unsigned char response[501];
	snprintf(&response[0],499,"Unknown command. Type %c/ChanServ help%c for a command listing.",2,2);
	response[499] = 0;
	services_say("ChanServ",response,uid);
}
void services_gateway_privmsg(int uid,const unsigned char* vstuff,const unsigned char* targetserv) {
	usleep(5);
	userpointers[uid]->floodprotect.floodpoints += 2;
	unsigned char stuff[500];
	strncpy(stuff,vstuff,499);
	stuff[499] = 0;
	trimleft(stuff);
	unsigned char cmd[40];
	strncpy(cmd,stuff,39);cmd[39] = 0;cutonfirstspace(cmd);
	unsigned char params[520];
	strncpy(params,stuff,519);params[519] = 0;if (charpos(params,32) >= 0) {cut(params,charpos(params,32)+1);}else{strcpy(params,"");}
	if (strcasecmp(targetserv,"nickserv") == 0) {
		services_nickserv(uid,cmd,params);
		return;
	}
	if (strcasecmp(targetserv,"chanserv") == 0) {
		services_chanserv(uid,cmd,params);
		return;
	}
}
void services_gateway_notice(int uid,const unsigned char* vstuff,const unsigned char* targetserv) {
	
}

